#!/usr/bin/perl
# -*- coding: utf-8 -*-
### ! C:\Perl64\bin\perl.exe
####################################################################################
#	Converter: ellipsoid summarized string to parameters
#
#	Ver. 1.0,  2017-2-5	Initial version
#	Ver. 1.01, 2017-2-8	Syntax updated
#	Ver. 1.1,  2017-2-26	Vibrato introduced
#	Ver. 1.11, 2017-2-27	Debugged
#
#	Copyright (C) 2017 by Yasusi Kanada, Dasyn.com
####################################################################################

print "Content-Type: text/html

<head><title>3D-printed shade summary string decoder</title></head>
<body>
<h1>3D-printed shade summary string decoder</h1>

";

$buffer = $ENV{'QUERY_STRING'};
foreach $pair (split(/&/, $buffer)){
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%(..)/pack("C", hex($1))/eg;
    $arg{$name} = $value;
}

if (!$arg{summary}) {  # initial phase
   print '<form action="unsummarize.cgi" method="get">', "\n";
   print '	<input type="text" name="summary" size="64" />', "\n";
   print '	<input type="submit" name="submit" value="Decode string" />', "\n";
   print '</form>', "\n";
} elsif ($arg{summary} =~
	 /AB(\d+)C(\d+)P(\d+)H(-?\d+)-(\d+)(W(\d+)-(\d+))?E(\d+)(-(\d+))?M([^D]*)D([^V]*)(V([^\.]*))?(\.gcode)?/) {
#           1     2     3     4       5    6 7     8       9    10 11     12     13     14 15       16
    $AB = $1;
    $C = $2;
    $pitch0 = $3 / 100.0;
    $HeightZ = $4;
    $Height = $5;
    $wcyc = $7 + 0;
    $wfac = $8 / 10000.0;
    $eafac = $9 / 100.0;
    if ($11) {
        $evfac = $11 / 100.0;
    } else {
        $evfac = 1.0;
    }
    @pm = split(/\$/, $12);
    @pd = split(/\$/, $13);
    @pv = split(/\$/, $15);

    print "String to be decoded: ", $arg{summary}, "\n";

    print "<h2>Basic parameters</h2>\n";

    print "AB = $AB, C = $C, pitch = $pitch0, Height = $5, Height0 = $4\n";

    print "<h2>Modulation</h2>\n";

    # decodeWave(\@pm);
    if (@pm == 0) {
	print "None\n";
    } else {
        print "<table>\n";
	print "  <tr>\n";
	print "    <td>Type</td><td>Amplitude</td>",
	      "<td>Cycle(a,b)</td><td>Cycle(c)</td></td><td>Shift</td>\n";
	print "  </tr>\n";
	for ($i = 1; $i < @pm; $i++) {
	    if ($pm[$i] =~ /(s|c|r)A(\d+)F(-?\d+)-(-?\d+)T(-?\d+)/) {
		$type = $1 == 's' ? 'sin': $1 == 'c' ? 'clip' : 'rectangular';
		$amplitude = $2 / 100.0;
		$freqR = $3;
		$freqZ = $4;
		$theta0 = $5 / 100.0;
		print "  <tr>\n";
		print "    <td>$type</td><td>$amplitude</td>",
		      "<td>$freqR</td><td>$freqZ</td><td>$theta0</td>\n";
		print "  </tr>\n";
	    } else {
	        print "ERROR:$pm[$i]\n";
	    }
	}
	print "</table>\n";
    }

    print "<h2>Deformation</h2>\n";

    if (@pd == 0) {
	print "None\n";
    } else {
        print "<table>\n";
	print "  <tr>\n";
	print "    <td>Type</td><td>Amplitude</td>",
	      "<td>Cycle(a,b)</td><td>Cycle(c)</td></td><td>Shift</td>\n";
	print "  </tr>\n";
	for ($i = 1; $i < @pd; $i++) {
	    if ($pd[$i] =~ /(s|c|r)A(\d+)F(-?\d+)-(-?\d+)T(-?\d+)/) {
		$type = $1 == 's' ? 'sin': $1 == 'c' ? 'clip' : 'rectangular';
		$amplitude = $2 / 100.0;
		$freqR = $3;
		$freqZ = $4;
		$theta0 = $5 / 100.0;
		print "  <tr>\n";
		print "    <td>$type</td><td>$amplitude</td>",
		      "<td>$freqR</td><td>$freqZ</td><td>$theta0</td>\n";
		print "  </tr>\n";
	    } else {
	        print "ERROR:$pd[$i]\n";
	    }
	}
	print "</table>\n";
    }

    print "<h2>Vibrato</h2>\n";

    if (@pv == 0) {
	print "None\n";
    } else {
        print "<table>\n";
	print "  <tr>\n";
	print "    <td>Type</td><td>Amplitude</td>",
	      "<td>Cycle(a,b)</td><td>Cycle(c)</td></td><td>Shift</td>\n";
	print "  </tr>\n";
	for ($i = 1; $i < @pv; $i++) {
	    if ($pv[$i] =~ /(s|c|r)A(\d+)F(-?\d+)-(-?\d+)T(-?\d+)/) {
		$type = $1 == 's' ? 'sin': $1 == 'c' ? 'clip' : 'rectangular';
		$amplitude = $2 / 10000.0;
		$freqR = $3;
		$freqZ = $4;
		$theta0 = $5 / 100.0;
		print "  <tr>\n";
		print "    <td>$type</td><td>$amplitude</td>",
		      "<td>$freqR</td><td>$freqZ</td><td>$theta0</td>\n";
		print "  </tr>\n";
	    } else {
	        print "ERROR:$pv[$i]\n";
	    }
	}
	print "</table>\n";
    }

    print "<h2>Additional parameters</h2>\n";

    print "wcyc = $wcyc, wfac = $wfac, eafac = $eafac, evfac = $evfac\n";

} else {
    print "Syntax error\n";
}

print "</body>
</html>
"
